/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2010, 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
function onOKBtnClicked(){
	// Validate the input fields
	if (!validateInputFields()) {
		resizeDialog();
		return false;
	}
	
	startWaiting();
	resizeDialog();
	return true;
}

/*
	Hide the dialog contents, insteadly display the waiting indicator.
*/
function startWaiting() {
	document.getElementById("contentDiv").style.display = "none";
	document.getElementById("waitingDiv").style.display = "block";
	resizeDialog();
}

/*
	Validate input fileds
*/
function validateInputFields(){
	//hide all of the validation message at first
	hideAllValidationMsg();
	
	var ipValue = $("view:form1:hostIPAddressInput").value;
	var userIdValue = $("view:form1:hostUserIDInput").value;
	var passwordValue = $("view:form1:hostPasswordInput").value;
		
	var ipv4Expression = /^(\d{1,3}\.){3}\d{1,3}$/;
		//DCR56(feature 14284) remove the IPv6 support
 		//var ipv6Expression = /^([0-9A-Fa-f]{1,4}:){7}[0-9A-Fa-f]{1,4}$/;
		var dnshostnameExpression= /^([a-zA-Z0-9-]+\.)*([a-zA-Z0-9-]+)$/
		//ip address can not be empty
		if(ipValue == null || ipValue == "")
		{
			$("hostip_nullmessage_div").style.display = "";
			return false;
		}
		
		// dnshome can't contain any character other than A-Z,a-z,0-9 and -(hyphen)
		if (!ipValue.match(ipv4Expression)){ //&& !ipValue.match(ipv6Expression)) {
			// The value of ip address field can't be recognized as IPv4
			if (ipValue.length > 75) {
				$("hostname_exceed_maxlength_div").style.display = "";
				return false;
			}
			if (!ipValue.match(dnshostnameExpression)) {
				$("hostname_illegal_char_div").style.display = "";
				return false;
			}
		}
		
		//user id can not be empty
		if(userIdValue == null || userIdValue == "")
		{
			$("userid_message_tr").style.display = "";
			return false;
		}
		//password can not be empty
		if(passwordValue == null || passwordValue == "")
		{
			$("password_message_tr").style.display = "";
			return false;
		}
		
		return true;
}

/*
	Hide all error messages
*/
function hideAllValidationMsg()	{
		$("hostip_nullmessage_div").style.display = "none";
		$("userid_message_tr").style.display = "none";
		$("password_message_tr").style.display = "none";
		$("hostname_illegal_char_div").style.display = "none";
		$("hostname_exceed_maxlength_div").style.display = "none";
};

function resizeDialog(){
	parent.resizeFrameHeight('dialog_iframe','dialog_iframe');
}
