/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2010, 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
FloatMessage.URL = basePath + "faces/ContextProgressServlet"
FloatMessage.QS_CONTEXT = "context";
FloatMessage.QS_MESSAGE = "message";
FloatMessage.STATIC = 0;
FloatMessage.DYNAMIC = 1;
FloatMessage.FINISH_INTERVAL = 2000;

var contentDiv;
var context;
var xmlHttpObj;
var req;
var contentHolder;

function FloatMessage(contextCode, mode, message)
{
	contentDiv = $("contentDiv");
	contentHolder = $("contentHolder");
	if(FloatMessage.DYNAMIC == mode)
	{
		context = contextCode;
	}
	else
	{
		contentHolder.innerHTML = message;
	}
	
	EventHandling.addEventHandler("scroll", window, adjust, false);
	EventHandling.addEventHandler("resize", window, adjust, false);
	
	this.start = function()
	{
		if(FloatMessage.DYNAMIC == mode)
		{
			start();
		}
		else
		{
			show();
		}
	}
	
	this.restart = function()
	{
		hide();
		start();
	}
}

function start()
{
	// xmlHttpObj must be refreshed every time, otherwise it will not work properly in IE
	xmlHttpObj = getXmlHttpObject();
	
	xmlHttpObj.onreadystatechange = onReqComplete;
	req = FloatMessage.URL + "?" + FloatMessage.QS_CONTEXT + "=" + context;
	// send message's hash value to server side to identify if there is any message change during round-trip
	if($("messageHash"))
	{
		req += "&" + FloatMessage.QS_MESSAGE + "=" + $("messageHash").innerHTML;
	}
	xmlHttpObj.open("GET", req, true);
	xmlHttpObj.send(null);
}

function onReqComplete()
{
	if(4 == xmlHttpObj.readyState)
	{
		if(200 == xmlHttpObj.status)
		{
			if(xmlHttpObj.responseText && xmlHttpObj.responseText.length > 0)
			{
				contentHolder.innerHTML = xmlHttpObj.responseText;
				if($("finished") && $("finished").innerHTML == "true")
				{
					setTimeout("hide()", FloatMessage.FINISH_INTERVAL);
				}
				else
				{
					show();
					start();
				}
			}
			else
			{
				// try fetching the progress data again
				start();
			}
		}
		//request timeout
		else if(408 == xmlHttpObj.status)
		{
			// try fetching the progress data again
			start();
		}
		else
		{
			setTimeout("hide()", FloatMessage.FINISH_INTERVAL);
		}
	}
}

function hide()
{
	contentDiv.style.display = "none";
}

function show()
{
	contentDiv.style.display = "";
	adjust();
	showWaitCursor(false);
}

function adjust()
{
	var docs = document.body;
	contentDiv.style.left = String(docs.scrollLeft + (docs.clientWidth  - contentDiv.clientWidth)  / 2) + "px";
	contentDiv.style.top = String(docs.scrollTop  + (docs.clientHeight - contentDiv.clientHeight) / 2) + "px";
}
