/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2010, 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */

var sspObj = new SelectStoragePool();

function SelectStoragePool()
{
	var oPoolTable;
	var oRadioCreatePoolNewEasy;
	var oRadioCreatePoolNewAdv;
	var oTableRadios;
	var oHiddenUsingExistingPool;
	
	this.init = function()
	{
		dataTableObj.init("view:form1:pools_table", null, DataTable.SINGLE);
		oPoolTable = $("view:form1:pools_table");
		oIsIR = false;
		oNoPool = false;
		try{
			if($("view:form1:is_no_pool").innerHTML == "true")
				oNoPool = true;
			if($("view:form1:is_IR").innerHTML=="true")
				oIsIR = true;
		}catch(e){}
		
		oTableRadios = getRadios(oPoolTable);
		oCreatePoolOptionRadios = getRadios($("create_pool_option_div"));
		oHiddenUsingExistingPool = $("view:form1:using_existing_pool")
		var usingExistingPool = oHiddenUsingExistingPool.value;
		if(oHiddenUsingExistingPool.value == "true"||oIsIR)
		{
			$("create_pool_existing").click();
		}
		else
		{
			$("create_pool_new").click();
		}
		if(oIsIR&&!oNoPool){
			$("create_pool_new").disabled = true;
		}
	}
	
	this.onCreateNewPoolClicked = function()
	{
		for(var i = 0; i < oCreatePoolOptionRadios.length; i++)
		{
			oCreatePoolOptionRadios[i].disabled = false;
		}
		for(var i = 0; i < oTableRadios.length; i++)
		{
			oTableRadios[i].disabled = true;
		}
		oHiddenUsingExistingPool.value = "false";
		$("view:form1:btn_next").disabled = false;
	}
	
	this.onUseExistPoolClicked = function()
	{
		for(var i = 0; i < oCreatePoolOptionRadios.length; i++)
		{
			oCreatePoolOptionRadios[i].disabled = true;
		}
		
		if(oTableRadios.length > 0)
		{
			var radioChecked = false;
			for(var i = 0; i < oTableRadios.length; i++)
			{
				oTableRadios[i].disabled = false;
				if(oTableRadios[i].checked == true)
				{
					radioChecked = true;
				}
			}
			if(!radioChecked)
			{
				//see if there is a selected pool id, if do, select the corresponding row
				var selectedPoolID = $("view:form1:selected_pool").value;
				if("" != selectedPoolID)
				{
					dataTableObj.setSelectedRow(selectedPoolID);
				}
				//otherwise select the first row by default
				else
				{
					oTableRadios[0].checked = true;
					dataTableObj.initTableRowState();
				}
			}
			oHiddenUsingExistingPool.value = "true";
			$("view:form1:btn_next").disabled = false;
		}
		else
		{
			$("view:form1:btn_next").disabled = true;
		}
	}
	
	function getRadios(parentElem)
	{
		var oInputs = parentElem.getElementsByTagName("input");
		var oRadios = new Array();
		for(var j = 0; j < oInputs.length; j++)
		{
			if(oInputs[j].type == "radio")
			{
				oRadios.push(oInputs[j]);
			}
		}
		return oRadios;
	}
	
	this.updateSelectedPool = function()
	{
		var id = dataTableObj.getSelectedIds();
		$("view:form1:selected_pool").value = id;
		showWaitCursor(true);
	}
}
