/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2010, 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
// Keeping the number of rows stored so that it doesnt have to be calculated
var numberOfDataRows = 0;
var DEVICE_LOG_SERVLET_PATH = basePath + "faces/DeviceLogServlet";
var xmlHttpObject;

// Variables used to add rows
var tableBody;
var newRows;

// The body onload initial method
function initDeviceLog()
{
	// If we hav the table and no "no records" message
	if(getDeviceLogTable() && !$("view:form1:norecords_desc"))
	{
		// Set the number of rows we have
		numberOfDataRows = getDeviceLogTable().rows.length;
		
		// If we have records then try to get more records
		getMoreLogsThroughAjax();
	}
	else
	{
		// Else if we dont have records, set the loaded timestamp
		setLoadCompleteTimestamp();
		
		// Also if no rows were gotten we may have an error
	    inlineMessagesAjaxObj.delayFetchMessages(500);
	}
}

function getMoreLogsThroughAjax()
{
	xmlHttpObject = getXmlHttpObject();
	
	// Add one to the start index
	var url = DEVICE_LOG_SERVLET_PATH + "?startIndex=" + (numberOfDataRows + 1);
	
	// Set the callback
	xmlHttpObject.onreadystatechange = ajaxCallback;
	
	// Make the request
	xmlHttpObject.open("GET", url, true);
	xmlHttpObject.send(null);
}

function ajaxCallback()
{
	if (xmlHttpObject.readyState == 4) 
	{
		// Here the request is complete
        
        if (xmlHttpObject.status == 200) 
        {
            // Here the response is valid
            
            // Set the response to a hidden div
            document.getElementById("newRowsDiv").innerHTML = xmlHttpObject.responseText;
            
            // Set up the variables
            newRows = document.getElementById("newRowsTable").rows;
			tableBody = getDeviceLogTable().getElementsByTagName("tbody")[0];
	        
	        // Set the loading message
	        $("lastrefresh_timestamp").innerHTML = document.getElementById("newLoadingMessage").innerHTML;
	        document.getElementById("newLoadingMessage").innerHTML = "";
	        
            if(newRows.length > 0)
            {
	            addRow(0, newRows.length - 1);
	    	}
	    	else
	    	{
	    		// If no log records were returned
	    		// Show the completed message
	    		
	    		setLoadCompleteTimestamp();
	    		
	    		// Also if no rows were gotten we may have an error
	    		inlineMessagesAjaxObj.fetchMessages();
	    	}
        }
        else
        {
        	// Here we had an error in the ajax request
        	
        	// Show the completed message
	    		
    		setLoadCompleteTimestamp();
    		
    		// Also we may have an error
    		inlineMessagesAjaxObj.displayFatalMessage();
        }
    }
}

function addRow(currentIndex, finalIndex)
{
	// Increase our row counter
	numberOfDataRows++;
				
	// Add the new row to the table
	newRows[0].style.display = "";	
	tableBody.appendChild(newRows[0]);
	
	// Set the loading message index
	document.getElementById("currentRowIndex").innerHTML = numberOfDataRows;
	
	if(currentIndex == finalIndex)
	{
		beepWhenRefresh();
		
		// We have added all the rows, now get some more
		getMoreLogsThroughAjax();
	}
	else
	{
		// Increment to the next row
		currentIndex++;
		
		// Wait a little to not block the CPU
		setTimeout("addRow(" + currentIndex + ", " + finalIndex + ");", 20);
	}
}

function getDeviceLogTable()
{
	return document.getElementById("view:form1:devicelog_table");
}

function setLoadCompleteTimestamp()
{
	$("lastrefresh_timestamp").innerHTML = getLocalizedCurrentTime();
}
