/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2010, 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
function BBUPropertiesObject()
{
	/////////////////////////////////////////////// INTERNAL VARIABLES ///////////////////////////////////////////////////////
	
	// The id of the controller associated with the BBU
	var controllerID = "";
	
	/////////////////////////////////////////////// SETTING UP ///////////////////////////////////////////////////////
	
	this.setControllerID = function(id)
	{
		controllerID = id;
	}
	
	/////////////////////////////////////////////// SHOW AND CLOSE ///////////////////////////////////////////////////////
	
	this.launchModal = function()
	{
		// Set the title to be the generic title
		this.setModalTitle(getElementByIdSuffix("defaultBBUPropertiesTitleConstant", "input").value);
		startWait();
		
		removeFormChildren();
		
		addParameter('controllerID', controllerID);
		
		// Launch the modal
		getElementByIdSuffix("bbuPropertiesSubview:bbuPropertiesLauncher", "input").click();
		
		// submit the form
		submitForm();
	}
	
	this.closeModal = function()
	{
		// Click the close button
		getElementByIdSuffix("bbuPropertiesSubview:hiddenStopShowingButton", "input").click();
		
		// Resize with a little delay
		setTimeout("bbuPropertiesObject.resizeParentShell()", 500);		
	}
	
	
	/////////////////////////////////////////////// WAITING ///////////////////////////////////////////////////////
	function startWait()
	{
		// Show the wait div and hide the dynamic div
		document.getElementById('bbuPropertiesLoadingDiv').style.display='block'; 
		document.getElementById('bbuPropertiesDynamicDiv').style.visibility='hidden';
		
		// Make the dynamic frame very small
		document.getElementById('bbuPropertiesDynamicFrame').style.height = "1px";	
	}
	
	this.dynamicFrameLoaded = function()
	{
		stopWait();
		
		this.resizeParentShell();
	}
	
	function stopWait()
	{	
		document.getElementById('bbuPropertiesLoadingDiv').style.display='none'; 
		document.getElementById('bbuPropertiesDynamicDiv').style.visibility='visible';
		
		resizeFrameHeight("bbuPropertiesDynamicFrame", "bbuPropertiesDynamicFrame");
	}
	
	/////////////////////////////////////////////// HELPERS ///////////////////////////////////////////////////////
		
	this.resizeParentShell = function()
	{
		// In case we were loaded into a shell system
		if(parent.document.getElementById("dynamicFrame"))
		{
			parent.resizeFrameHeight("dynamicFrame", "dynamicFrame");
		}
	}	
	
	this.setModalTitle = function(newTitle)
	{
		//can not replace the title using innerHTML. otherwise the close icon link will be link to a certain page when click the close icon.
		$("view:bbuPropertiesSubview:bbuPropertiesModal_tb").lastChild.nodeValue = newTitle;
		$("view:bbuPropertiesSubview:bbuPropertiesModal_tb").title = newTitle;
	}
	
	/////////////////////////////////////////////// POSTING DATA ///////////////////////////////////////////////////////
	
	//the added parameter will be created as input hidden field in form.
	function addParameter(name, value)
	{	
		var bbuPropertiesForm = $("bbuPropertiesForm");
		var input = document.createElement("input");
		input.type="hidden";
		input.name=name;
		input.id=name;
		input.value=value;
		bbuPropertiesForm.insertBefore(input,bbuPropertiesForm.lastChild);
	}
	
	//remove all the nodes in paneldialog_form
	function removeFormChildren()
	{
		var bbuPropertiesForm = document.getElementById("bbuPropertiesForm");
		bbuPropertiesForm.innerHTML="";
	}
	
	//submit the form
	function submitForm() 
	{
		var bbuPropertiesForm = document.getElementById("bbuPropertiesForm");
		bbuPropertiesForm.submit();
	}
}

var bbuPropertiesObject = new BBUPropertiesObject();
