/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2010, 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
// ------------------------------------------ SELECTOIN/FIXING ---------------------------------------------

var ENCLOSURE_PROPERTIES_DIALOG_PATH = "faces/page/physical/EnclosureProperties.jsp";

function checkboxClicked(checkbox, rowIndex)
{
	var table = document.getElementById("enclosuresTable");
	var rows = table.rows;
	
	if(checkbox.checked)
	{
		// This checkbox was just selected, the row style needs to be changed
		rows[rowIndex].className = "scm_DataTableSelected_Row";	
	}
	else
	{
		// The checkbox was unchecked, so make the row a sample color and we will fix it up
		rows[rowIndex].className = "scm_DataTable_Row";
	}
	
	fixUpRowStyles(table);
	
	enableDisableActions();
}

function enableDisableActions()
{
	var menu = hX_5.getComponentById("view:form1:actionsMenu");
	
	// We need to check if any enclosures are selected and enable/disable the button
	var numberSelected = getNumberSelected();
	
	if(numberSelected > 0)
	{
		// We can locate one or more
		enableMenuItem(menu, "view:form1:locateDrivesLink");
		document.getElementById("view:form1:locateDrivesButton").disabled = false;
		$("view:form1:locateDrivesLink").onclick=locateDrivesClicked;
		
		// We can only see properties for one
		if(numberSelected == 1)
		{
			enableMenuItem(menu, "view:form1:propertiesLink");
			$("view:form1:propertiesLink").onclick=propertiesClicked;
		}
		else
		{
			disableMenuItem(menu, "view:form1:propertiesLink");
			$("view:form1:propertiesLink").onclick="";
		}
	}
	else
	{
		// If nothing is selected we cant do anything
		
		disableMenuItem(menu, "view:form1:locateDrivesLink");
		$("view:form1:locateDrivesLink").onclick="";
		
		document.getElementById("view:form1:locateDrivesButton").disabled = true;
		
		disableMenuItem(menu, "view:form1:propertiesLink");
		$("view:form1:propertiesLink").onclick="";
	}
}

function getNumberSelected()
{
	var checkboxes = document.getElementsByName("selectedEnclosures");
	
	var sum = 0;
	
	for(var x = 0; x < checkboxes.length; x++)
	{
		if(checkboxes[x].checked)
		{
			sum++;
		}
	}
	
	return sum;
}

function fixUpRowStyles(table)
{
	var rows = table.rows;
	
	// Start from 1
	for(var x = 1; x < rows.length; x++)
	{
		// Skip highlighted rows
		if(rows[x].className != "scm_DataTableSelected_Row")
		{
			if(x % 2 == 1)
			{
				rows[x].className = "scm_DataTable_Row";
			}
			else
			{
				rows[x].className = "scm_DataTable_RowGray";
			}
		}
	}
}

// ------------------------------------------ PROPERTIES ---------------------------------------------

function showEnclosureProperties(enclosureID)
{
	//set title
	var title = $("view:dialog_title").innerHTML;
	panelDialogObj.setPanelDialogTitle("view", title);
	var action = ENCLOSURE_PROPERTIES_DIALOG_PATH;
	panelDialogObj.addParameter("enclosureid", enclosureID); 
	panelDialogObj.launchDialogPOST("view", action, '620');
}

function propertiesClicked()
{
	// We can only get here if one enclosure is selected
	showEnclosureProperties(getSelectedIDs()[0]);
}

// ------------------------------------------ LOCATE ---------------------------------------------
function locateDrivesClicked()
{
	var selectedIds = getSelectedIDs();
	
	// Make sure to clear out any previously selected resources
	locateObject.removeAllResourcesToLocate();
	
	// Add the currently selected object
	for(var x = 0; x < selectedIds.length; x++)
	{
		locateObject.addResourceToLocate(selectedIds[x]);
	}

	locateObject.setLocateType(locateObject.ENCLOSURE_CONSTANT);
	
	// Start the locate
	locateObject.startLocate();
}

// ------------------------------------------ OTHER ---------------------------------------------
function refresh()
{
	// If refresh button is clicked, the context will be reloaded, so the others tab pages should be reloaded as well
	
	// Seeing which tabs are available in the framework object
	
	if(parent.parent.frameworkObj.setDiskReload)
	{
		parent.parent.frameworkObj.setDiskReload(true);
	}
	
	parent.loaded = false;
	
	parent.$('staticLoadingFrame').contentWindow.restartFloatMessage();
	
	parent.startShellLoading();
}

function setLastRefreshDate()
{
	document.getElementById('lastRefreshTimestamp').innerHTML = getLocalizedCurrentTime();
}

function getSelectedIDs()
{
	var checkboxes = document.getElementsByName("selectedEnclosures");
	
	var ids = new Array();
	
	for(var x = 0; x < checkboxes.length; x++)
	{
		if(checkboxes[x].checked)
		{
			ids.push(checkboxes[x].value);
		}
	}
	
	return ids;
}
