/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2010, 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
var assignPoolDedicatedHotSpareObj = new AssignPoolDedicatedHotSpare();

AssignPoolDedicatedHotSpare.VIEW_FORM_ID = "view:form1";

function AssignPoolDedicatedHotSpare()
{

	this.init = function()
	{
		//initial the ok button to be disable.
		$(AssignPoolDedicatedHotSpare.VIEW_FORM_ID+":ok_btn").disabled = true;
	};
	
	//if at least one disk drive is selected, enable the ok button, otherwise disable the button
	this.changeOkBtn = function()
	{
		
		if(dataTableObj.isRowSelected())
		{
			//enable ok button
			$(AssignPoolDedicatedHotSpare.VIEW_FORM_ID+":ok_btn").disabled = false;
		}else{
			//disable ok button
			$(AssignPoolDedicatedHotSpare.VIEW_FORM_ID+":ok_btn").disabled = true;
		}
	};
	
	//assign the selected disk drives as Global Spare drive.
	this.onOKBtnClick = function(thisObj, thisEvent)
	{
		//set the selected ids to the hidden fileds, so that it can be got in page code.
		$(AssignPoolDedicatedHotSpare.VIEW_FORM_ID+":diskdrive_ids").value = dataTableObj.getSelectedIds();
		//trigger ajax request
		$(AssignPoolDedicatedHotSpare.VIEW_FORM_ID+":assign_spare_launcher").click();
	};
	
	this.onCancelBtnClick = function(thisObj, thisEvent)
	{
		//close self page
		parent.getElementByIdSuffix("form1:dedicated_spare_cancel_btn", "input").click();
	};
	
	
	this.onAssignSpareComplete = function()
	{
		var assignSucceed = $(AssignPoolDedicatedHotSpare.VIEW_FORM_ID+":assign_succeed").innerHTML;
		if(assignSucceed == "true")
		{
			//close self page
			parent.getElementByIdSuffix("form1:dedicated_spare_cancel_btn", "input").click();
		}else{
			//hide the wait div
			$("loading_div").style.display="none";
			inlineMessagesAjaxObj.fetchMessages();
			document.body.style.cursor='default';
			enableAllBtns();
		}
	}
	
	this.onAssignSpareError = function()
	{
		//hide the wait div
		$("loading_div").style.display="none";
		//display the fatal message.
		inlineMessagesAjaxObj.displayFatalMessage();
		document.body.style.cursor='default';
		enableAllBtns();
	}
	
	this.onAssignSpareStart = function()
	{
		//display the wait div
		$("loading_div").style.display="block";
		document.body.style.cursor='wait';
		disableAllBtns();
		
	}
	
	function enableAllBtns()
	{
		$(AssignPoolDedicatedHotSpare.VIEW_FORM_ID+":ok_btn").disabled = false;
		$(AssignPoolDedicatedHotSpare.VIEW_FORM_ID+":cancel_btn").disabled = false;
	}

	function disableAllBtns()
	{
		$(AssignPoolDedicatedHotSpare.VIEW_FORM_ID+":ok_btn").disabled = false;
		$(AssignPoolDedicatedHotSpare.VIEW_FORM_ID+":cancel_btn").disabled = false;
	}
	
}
