/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2010, 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
var deletePoolConfirmationObj = new DeletePoolConfirmation();

DeletePoolConfirmation.VIEW_FORM_ID = "view:form1";

function DeletePoolConfirmation()
{
	//delete the pool when click the ok button
	this.onOKBtnClick = function(thisObj, thisEvent)
	{
		var ajaxLauncherBtn = $(DeletePoolConfirmation.VIEW_FORM_ID+":delete_pool_launcher");
		ajaxLauncherBtn.click();
	}
	
	this.loadVolumes = function()
	{
		var panelDisplay = $(DeletePoolConfirmation.VIEW_FORM_ID+":loadvolumes_panel").style.display;
		if(panelDisplay=="none")
		{
			var ajaxLauncherBtn = $(DeletePoolConfirmation.VIEW_FORM_ID+":load_volumes_launcher");
			ajaxLauncherBtn.click();
		}
		
	};
	
	this.onLoadVolumesComplete = function()
	{
		//hide the wait div
		$("wait_div").style.display="none";
		$(DeletePoolConfirmation.VIEW_FORM_ID+":loadvolumes_panel").style.display="block";
		parent.resizeFrameHeight('dialog_iframe', 'dialog_iframe');
		$(DeletePoolConfirmation.VIEW_FORM_ID+":ok_btn").disabled = false;
		$(DeletePoolConfirmation.VIEW_FORM_ID+":cancel_btn").disabled = false;
	};
	
	this.onLoadVolumesStart = function()
	{
		//display the wait div
		$("wait_div").style.display="block";
		parent.resizeFrameHeight('dialog_iframe', 'dialog_iframe');
		$(DeletePoolConfirmation.VIEW_FORM_ID+":ok_btn").disabled = true;
		$(DeletePoolConfirmation.VIEW_FORM_ID+":cancel_btn").disabled = true;
	};
	
	this.onAjaxError = function()
	{
		//close the dialog.
		parent.panelDialogObj.closeDialog();
		//show fatal inline message on storage page.
		parent.parent.parent.inlineMessagesAjaxObj.displayFatalMessage();
	};
	
	this.onDeletePoolComplete = function()
	{
		//close the dialog and refresh the parent page.
		//refresh the parent page.
		var parentRfreshBtn = parent.document.getElementById(parent.Pools.VIEW_FORM_ID+":refresh_btn");
		parentRfreshBtn.click();
	};
	
	this.onDeletePoolStart = function()
	{
		//display the loading td
		$("loading_div").style.display = "";
		$(DeletePoolConfirmation.VIEW_FORM_ID+":ok_btn").disabled = true;
		$(DeletePoolConfirmation.VIEW_FORM_ID+":cancel_btn").disabled = true;
	};
	
	this.expandVolumeTable = function(thisObj,thisEvent,alt1,alt2)
	{
		if($("volumes_div").style.display == "none")
		{
			this.loadVolumes();
		}
		toggleExpandCollapse(thisObj,'images/expandcollapse/arrow_right.gif', alt1, 'images/expandcollapse/arrow_down.gif', alt2,  'volumes_div'); 
		parent.resizeFrameHeight('dialog_iframe', 'dialog_iframe');
	};

}
