/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2010, 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
var actionCommitted = false;

function EditVolumePropertiesShell()
{
	var volumeID = "";
	
	var dialogTitle = "";
	
	this.setDialogTitle = function(title)
	{
		dialogTitle = title;
	}
	
	this.setVolumeID = function(id)
	{
		volumeID = id;
	}
	
	/////////////////////////////////////////////// SHOW AND CLOSE ///////////////////////////////////////////////////////
	
	this.launchModal = function()
	{
		// Set the title to be the generic title
		setModalTitle();
		startWait();
		
		removeFormChildren();
		
		addParameter('volumeID', volumeID);
		
		// Launch the modal
		getElementByIdSuffix("EditVolumePropertiesSubview:EditVolumePropertiesLauncher", "input").click();
		
		// submit the form
		submitForm();
	}
	
	this.closeModal = function()
	{
		// Click the close button
		getElementByIdSuffix("EditVolumePropertiesSubview:hiddenStopShowingButton", "input").click();		
	}
	
	this.closeAndRefresh = function()
	{
		this.closeModal();
		panelDialogObj.frameLoadStart();
	}
	
	/////////////////////////////////////////////// WAITING ///////////////////////////////////////////////////////
	function startWait()
	{
		// Show the wait div and hide the dynamic div
		$('EditVolumePropertiesLoadingDiv').style.display='block'; 
		$('EditVolumePropertiesDynamicDiv').style.visibility='hidden';
		
		// Make the dynamic frame very small
		$('EditVolumePropertiesDynamicFrame').style.height = "1px";	
	}
	
	this.dynamicFrameLoaded = function()
	{
		if(actionCommitted == true)
		{
			volumeObj.launchPropertiesDialogWithTabIndex('3');
			actionCommitted = false;
		}
		stopWait();
	}
	
	function stopWait()
	{	
		$('EditVolumePropertiesLoadingDiv').style.display='none'; 
		$('EditVolumePropertiesDynamicDiv').style.visibility='visible';
		
		resizeFrameHeight("EditVolumePropertiesDynamicFrame", "EditVolumePropertiesDynamicFrame");
	}
	
	function setModalTitle()
	{
		var titleDiv = getElementByIdSuffix("EditVolumePropertiesSubview:EditVolumePropertiesModal_tb", "div");
		
		var newHTML = titleDiv.innerHTML.replace(titleDiv.title, dialogTitle);
	
		titleDiv.innerHTML = newHTML;
		
		titleDiv.title = dialogTitle;
	}
	
	/////////////////////////////////////////////// POSTING DATA ///////////////////////////////////////////////////////
	
	//the added parameter will be created as input hidden field in form.
	function addParameter(name, value)
	{	
		var editVolumePropertiesForm = $("EditVolumePropertiesForm");
		var input = document.createElement("input");
		input.type="hidden";
		input.name=name;
		input.id=name;
		input.value=value;
		editVolumePropertiesForm.insertBefore(input,editVolumePropertiesForm.lastChild);
	}
	
	//remove all the nodes in paneldialog_form
	function removeFormChildren()
	{
		var editVolumePropertiesForm = document.getElementById("EditVolumePropertiesForm");
		editVolumePropertiesForm.innerHTML="";
	}
	
	//submit the form
	function submitForm() 
	{
		var editVolumePropertiesForm = document.getElementById("EditVolumePropertiesForm");
		editVolumePropertiesForm.submit();
	}
}

var evpsObj = new EditVolumePropertiesShell();
