/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2010, 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
var initializeDrivesConfirmationObj = new InitializeDrivesConfirmation();

InitializeDrivesConfirmation.VIEW_FORM_ID = "view:form1";
InitializeDrivesConfirmation.ID_DELIMITER = ";";

function InitializeDrivesConfirmation()
{
	//delete the pool when click the ok button
	this.onOKBtnClick = function(thisObj, thisEvent)
	{
		$(InitializeDrivesConfirmation.VIEW_FORM_ID+":drive_ids").value=getAllDriveIds();
		var ajaxLauncherBtn = $(InitializeDrivesConfirmation.VIEW_FORM_ID+":initialize_drives_launcher");
		ajaxLauncherBtn.click();
	}

	
	this.onInitializeComplete = function()
	{
		//close the dialog and refresh the parent page.
		//refresh the parent page.
		var parentRefreshBtn = parent.document.getElementById(parent.DiskDrives.VIEW_FORM_ID+":refresh_btn");
		parentRefreshBtn.click();
	};
	
	this.onInitializeStart = function()
	{
		//display the loading td
		$("loading_div").style.display = "";
		$(InitializeDrivesConfirmation.VIEW_FORM_ID+":ok_btn").disabled = true;
		$(InitializeDrivesConfirmation.VIEW_FORM_ID+":cancel_btn").disabled = true;
	};
	
	this.onAjaxError = function()
	{
		//close the dialog.
		parent.panelDialogObj.closeDialog();
		//show fatal inline message on storage page.
		parent.parent.parent.inlineMessagesAjaxObj.displayFatalMessage();
	};
	
	
	function getAllDriveIds()
	{
		var ids = "";
		var table = $(InitializeDrivesConfirmation.VIEW_FORM_ID+":drives_table");
		var rows = table.rows;
		if(rows != null && rows.length >1)
		{
			for(var i=1; i<rows.length; i++)
			{
				var id_cell = rows[i].cells[0].childNodes[0].innerHTML;
				if(i==1)
				{
					ids = id_cell;
				}else{
					ids = ids + InitializeDrivesConfirmation.ID_DELIMITER + id_cell;
				}
			}
		}
		return ids;
	};
	

}
