/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2010, 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
var poolPropertiesObj = new PoolProperties();

PoolProperties.VIEW_FORM_ID = "view:form1";

function PoolProperties()
{	
	this.init = function()
	{
		//disable locate drive button
		var locateDriveBtn = $(PoolProperties.VIEW_FORM_ID+":locatedrive_btn");
		locateDriveBtn.disabled = true;
	};

	this.refreshLocateDrivesBtn = function()
	{
		var selectedCount = dataTableObj.getSelectedRowCount();
		var locateDriveBtn = $(PoolProperties.VIEW_FORM_ID+":locatedrive_btn");
		if(selectedCount>0)
		{
			locateDriveBtn.disabled = false;
		}else{
			locateDriveBtn.disabled = true;
		}
	};
	
	//launch the locateshell jsp.
	this.onClickLocateDrivesBtn = function(thisObj, thisEvent)
	{
		var selectedIds = dataTableObj.getSelectedIds();
		
		// Make sure to clear out any previously selected resources
		locateObject.removeAllResourcesToLocate();
		
		// Add the currently selected object
		if(selectedIds != "")
		{
			var selectedIdArray = selectedIds.split(DataTable.ID_DELIMITER);
			for(var i=0; i<selectedIdArray.length; i++)
			{
				locateObject.addResourceToLocate(selectedIdArray[i]);
			}
		}

		locateObject.setLocateType(locateObject.DISK_CONSTANT);
		// Start the locate
		locateObject.startLocate();
	};
	
	this.onTabEnter = function(thisObj, thisEvent)
	{
		var panelId = thisEvent.tobeEnterPanel;
		if(panelId.endWith("poolproperties_volumes"))
		{
			//adjust the width
			setTimeout("dataTableObj.initHeaderDivPaddingWidth('view:form1:volumes_table','table_header_div_volume')", 200);
		}else{
			if(panelId.endWith("poolproperties_diskdrives"))
			{
				//adjust the width
				setTimeout("dataTableObj.initHeaderDivPaddingWidth('view:form1:diskdrives_table','table_header_div_disk')", 200);
			}
		}
	}
	
	
}
