/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2010, 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
var poolsObj = new Pools();

Pools.VIEW_ID = "view";
Pools.VIEW_FORM_ID = "view:form1";
Pools.VIEW_ID = "view";
Pools.POOL_DELETE_DIALOG_PATH = "faces/page/storage/DeletePoolConfirmation.jsp";
Pools.POOL_PROPERTIES_DIALOG_PATH = "faces/page/storage/PoolProperties.jsp";

Pools.POOL_SPARE_NONE = 0;
Pools.POOL_SPARE_DEDICATED = 1;
Pools.POOL_SPARE_GLOBAL = 2;
Pools.POOL_SPARE_BOTH = 3;

Pools.SPARE_COL_IDX = 7;
Pools.CAPACITY_COL_IDX = 4;
Pools.RAIDTYPE_COL_IDX = 6;
Pools.VOLUMEQUANTITY_COL_IDX = 5;

function Pools()
{	
	this.init = function()
	{
		refreshTimestamp();
		//disabled create volume button
		$(Pools.VIEW_FORM_ID + ":createvolumes_btn").disabled = true;
		
	};
	
	this.changeMenusNBtns = function()
	{
		var actionMenu = hX_5.getComponentById(Pools.VIEW_FORM_ID+":actionmenu");
		//properties menu
		var propertiesItem = actionMenu.getMenuItemById(Pools.VIEW_FORM_ID+":properties_link");
		hX_5.getSubComponentById(propertiesItem).setAttribute("disabled:false");
		$(Pools.VIEW_FORM_ID+":properties_link").onclick = poolsObj.onClickPropertiesMenu;
		
		//create volume
		var createVolumeItem = actionMenu.getMenuItemById(Pools.VIEW_FORM_ID+":create_volumes_link");
		if(isPoolWithAvailableCapacity())
		{
			$(Pools.VIEW_FORM_ID + ":createvolumes_btn").disabled = false;
			hX_5.getSubComponentById(createVolumeItem).setAttribute("disabled:false");
			$(Pools.VIEW_FORM_ID+":create_volumes_link").onclick=poolsObj.onCreateVolume;
		}
		else
		{
			$(Pools.VIEW_FORM_ID + ":createvolumes_btn").disabled = true;
			hX_5.getSubComponentById(createVolumeItem).setAttribute("disabled:true");
			$(Pools.VIEW_FORM_ID+":create_volumes_link").onclick="";
		}
		//delete pool
		var deletePoolItem = actionMenu.getMenuItemById(Pools.VIEW_FORM_ID+":delete_storagepool_link");
		hX_5.getSubComponentById(deletePoolItem).setAttribute("disabled:false");
		$(Pools.VIEW_FORM_ID+":delete_storagepool_link").onclick=poolsObj.onClickDeletePoolMenu;
		
		//locate drives
		var locateDriverItem = actionMenu.getMenuItemById(Pools.VIEW_FORM_ID+":locate_driver_link");
		hX_5.getSubComponentById(locateDriverItem).setAttribute("disabled:false");
		$(Pools.VIEW_FORM_ID+":locate_driver_link").onclick=poolsObj.onClickLocateDrivesMenu;
		
		//assign global/dedicated spare
		var assignGlobalSpareItem = actionMenu.getMenuItemById(Pools.VIEW_FORM_ID+":assign_globalspare_link");
		var assignDedicatedItem = actionMenu.getMenuItemById(Pools.VIEW_FORM_ID+":assign_dedicatedspare_link");
		if (isPoolRaid0() || isPoolNoVolumes()) {
			hX_5.getSubComponentById(assignDedicatedItem).setAttribute("disabled:true");
			$(Pools.VIEW_FORM_ID+":assign_dedicatedspare_link").onclick="";
		} else {
			hX_5.getSubComponentById(assignDedicatedItem).setAttribute("disabled:false");
			$(Pools.VIEW_FORM_ID+":assign_dedicatedspare_link").onclick=poolsObj.onClickAssignDedicatedSpareMenu;
		}
		
		//unassign a dedicated spare
		var unAssignDedicatedItem = actionMenu.getMenuItemById(Pools.VIEW_FORM_ID+":unassign_dedicatedspare_link");
		if(isAllDedicatedSpareDisk() && !isPoolRaid0())
		{
			hX_5.getSubComponentById(unAssignDedicatedItem).setAttribute("disabled:false");
			$(Pools.VIEW_FORM_ID+":unassign_dedicatedspare_link").onclick=poolsObj.onClickUnassignDedicatedSpareMenu;
		}else{
			hX_5.getSubComponentById(unAssignDedicatedItem).setAttribute("disabled:true");
			$(Pools.VIEW_FORM_ID+":unassign_dedicatedspare_link").onclick="";
		}
		
		actionMenu.redraw();
	};
		
	//listener for the pool name link click event.
	this.onClickPoolLink = function(thisObj)
	{
		//check the hidden radio button
		var oRow = thisObj.parentNode.parentNode.parentNode;
		var poolId = oRow.cells[0].getElementsByTagName("input")[1].value;// the second input is the hidden input
		launchPropertiesDialog(poolId);
	};

	//listener for the properties menu click event
	this.onClickPropertiesMenu = function()
	{
		var poolId = dataTableObj.getSelectedIds();
		launchPropertiesDialog(poolId);
	};
	
	
	//redirect to AssignGlobalHotSpare.jsp
	this.onClickAssignGlobalSpareMenu = function()
	{
		parent.parent.parent.getElementByIdSuffix("form1:pool_tab_assign_global_spare_btn", "input").click();
	};
	
	//redirect to AssignPoolDedicatedHotSpare.jsp
	this.onClickAssignDedicatedSpareMenu = function()
	{
		var selectedId = dataTableObj.getSelectedIds();
		parent.parent.parent.getElementByIdSuffix("pool_tab_dedicated_spare_selected_poolid", "input").value = selectedId;
		parent.parent.parent.getElementByIdSuffix("form1:pool_tab_assign_dedicated_spare_btn", "input").click();
	};
	
	//redirect to UnassignPoolDedicatedHotSpare.jsp
	this.onClickUnassignDedicatedSpareMenu = function()
	{
		var selectedId = dataTableObj.getSelectedIds();
		parent.parent.parent.getElementByIdSuffix("pool_tab_dedicated_spare_selected_poolid", "input").value = selectedId;
		parent.parent.parent.getElementByIdSuffix("form1:pool_tab_unassign_dedicated_spare_btn", "input").click();
	};

	//launch the locateshell jsp.
	this.onClickLocateDrivesMenu = function()
	{
		var selectedIds = dataTableObj.getSelectedIds();
		
		// Make sure to clear out any previously selected resources
		locateObject.removeAllResourcesToLocate();
		
		// Add the currently selected object
		if(selectedIds != "")
		{
			var selectedIdArray = selectedIds.split(DataTable.ID_DELIMITER);
			for(var i=0; i<selectedIdArray.length; i++)
			{
				locateObject.addResourceToLocate(selectedIdArray[i]);
			}
		}
		locateObject.setLocateType(locateObject.POOL_CONSTANT);
		// Start the locate
		locateObject.startLocate();
	};

	//show the pool deletion confirmation dialog
	this.onClickDeletePoolMenu = function()
	{
		launchPoolDeletionDialog();
	}
	
	this.onCreateVolume = function()
	{
		var selectedId = dataTableObj.getSelectedIds();
		parent.parent.parent.getElementByIdSuffix("form1:pool_tab_create_volume_selected_pool_id", "input").value = selectedId;
		parent.parent.parent.getElementByIdSuffix("form1:btn_pool_tab_create_volume", "input").click();
	}
	
	this.onCreatePool = function()
	{
		parent.parent.parent.getElementByIdSuffix("form1:btn_pool_tab_create_pool", "input").click();
	}

	//click the refresh button
	this.onClickRefreshBtn = function()
	{
		//if click the refresh button, the context will be reloaded, so the others tab pages should be reloaded as well.
		parent.parent.frameworkObj.setVolumeReload(true); 
		parent.parent.frameworkObj.setDiskReload(true);
		parent.$('staticLoadingFrame').contentWindow.restartFloatMessage();
		parent.loaded = false;
		parent.startShellLoading();
	}



	function launchPropertiesDialog(poolId)
	{
		//set title
		var title = $("view:dialog_title").innerHTML;
		setPanelDialogTitle(title);
		var action = Pools.POOL_PROPERTIES_DIALOG_PATH;
		panelDialogObj.addParameter("poolId", poolId);
		panelDialogObj.launchDialogPOST(Pools.VIEW_ID,action,'620');
	};
	
	function launchPoolDeletionDialog()
	{
		//set title
		setPanelDialogTitle($('view:delete_pool_dialog_title').innerHTML);
		var action = Pools.POOL_DELETE_DIALOG_PATH;
		panelDialogObj.addParameter("poolId", dataTableObj.getSelectedIds());
		panelDialogObj.launchDialogPOST(Pools.VIEW_ID,action,'550');
	};

	//set the panel dialog title
	function setPanelDialogTitle(title)
	{
		panelDialogObj.setPanelDialogTitle(Pools.VIEW_ID, title);
	};
	
	function refreshTimestamp()
	{
		$("lastrefresh_timestamp").innerHTML = getLocalizedCurrentTime();
	};
	
	function isAllDedicatedSpareDisk()
	{
		var selectedRowElems = dataTableObj.getSelectedRowElems();
		if(selectedRowElems != null && selectedRowElems.length>0)
		{
			for(var i=0; i<selectedRowElems.length; i++)
			{
				var rowElem = selectedRowElems[i];
				var state = rowElem.cells[Pools.SPARE_COL_IDX].childNodes[0].childNodes[0].innerHTML;
				//if at least one non-unconfigured and non-dedicated drive has been selected, return false;
				if(state != Pools.POOL_SPARE_DEDICATED && state != Pools.POOL_SPARE_BOTH)
				{
					return false;
				}
			}
		}
		return true;
	}
	
	function isPoolWithAvailableCapacity()
	{
		var selectedRowElems = dataTableObj.getSelectedRowElems();
		if(selectedRowElems != null && selectedRowElems.length>0)
		{
			for(var i=0; i<selectedRowElems.length; i++)
			{
				var rowElem = selectedRowElems[i];
				var capacity = rowElem.cells[Pools.CAPACITY_COL_IDX].childNodes[0].childNodes[0].innerHTML;
				//if at least one non-unconfigured and non-dedicated drive has been selected, return false;
				if(capacity == "0")
				{
					return false;
				}
			}
		}
		else
		{
			return false;
		}
		return true;
	}
	
	function isPoolRaid0() {
		var selectedRowElems = dataTableObj.getSelectedRowElems();
		if(selectedRowElems != null && selectedRowElems.length>0)
		{
			for(var i=0; i<selectedRowElems.length; i++)
			{
				var rowElem = selectedRowElems[i];
				var raidType = rowElem.cells[Pools.RAIDTYPE_COL_IDX].childNodes[0].childNodes[0].innerHTML;
				
				if(raidType ==  $("view:display_name_raid_0").innerHTML)
				{
					return true;
				}
			}
		}
		return false;
	}
	
	function isPoolNoVolumes()
	{
		var selectedRowElems = dataTableObj.getSelectedRowElems();
		if(selectedRowElems != null && selectedRowElems.length>0)
		{
			for(var i=0; i<selectedRowElems.length; i++)
			{
				var rowElem = selectedRowElems[i];
				var volumeQuantity = Number(rowElem.cells[Pools.VOLUMEQUANTITY_COL_IDX].childNodes[0].childNodes[0].innerHTML);
				
				if(volumeQuantity==0)
				{
					return true;
				}
			}
		}
		return false;
	}
	
	
}
