/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2010, 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
var frameworkObj = new Storage();

function Storage()
{
	var storageTab = new TabbedPanel(3, "view:form1");
	
	var volumeTabPage = "faces/page/storage/VolumesView.jsp";
	var poolTabPage = "faces/page/storage/PoolsView.jsp";
	var diskTabPage = "faces/page/storage/DiskDrivesView.jsp?parent=storage";
	
	var volumeReload = false;
	var poolReload = false;
	var diskReload = false;
	
	this.initFrame = function()
	{
		var previousSelectedTab = parent.previousSelectedTabObj.getPreviousSelectedTab();
		if(previousSelectedTab != null && previousSelectedTab != "")
		{
			ODCTabPanelControlVar1.restoreUIState(previousSelectedTab);
			switch(previousSelectedTab)
			{
				case parent.PreviousSelectedTab.STORAGE_TAB_VOLUME:
					$("volume_iframe").src = basePath + volumeTabPage;
					break;
					
				case parent.PreviousSelectedTab.STORAGE_TAB_POOL:
					$("pool_iframe").src = basePath + poolTabPage;
					break;
					
				case parent.PreviousSelectedTab.STORAGE_TAB_DISK:
					$("disk_iframe").src = basePath + diskTabPage;
					break;
			}
		}else{
			$("volume_iframe").src = basePath + volumeTabPage;
		}
		
	}
	
	this.onTabEnter = function(thisObj, thisEvent)
	{
		var panelId = thisEvent.tobeEnterPanel;
		var objFrame;
		
		if(panelId.endWith("volume_tab"))
		{
			if(volumeReload == true  || !$("volume_iframe").src.endWith(volumeTabPage))
			{
				$("volume_iframe").src = basePath + volumeTabPage;
				volumeReload = false;
			}else{
				if($("volume_iframe").contentWindow.loaded == true)
				{
					setTimeout("$('volume_iframe').contentWindow.stopShellLoading();", 50);
					setTimeout("$('volume_iframe').contentWindow.$('dynamicFrame').contentWindow.dataTableObj.initHeaderDivPaddingWidth('view:form1:volumes_table');", 200);					
				}
			}
		}
		else if(panelId.endWith("pool_tab"))
		{
			if(poolReload == true || !$("pool_iframe").src.endWith(poolTabPage))
			{
				$("pool_iframe").src = basePath + poolTabPage;
				poolReload = false;
			}else{
				if($("pool_iframe").contentWindow.loaded == true)
				{
					setTimeout("$('pool_iframe').contentWindow.stopShellLoading();", 50);
					setTimeout("$('pool_iframe').contentWindow.$('dynamicFrame').contentWindow.dataTableObj.initHeaderDivPaddingWidth('view:form1:pools_table');", 200);				
				}
			}
		}
		else if(panelId.endWith("disk_tab"))
		{
			if(diskReload == true || !$("disk_iframe").src.endWith(diskTabPage))
			{
				$("disk_iframe").src = basePath + diskTabPage;
				diskReload = false;
			}else{
				if($("disk_iframe").contentWindow.loaded == true)
				{
					setTimeout("$('disk_iframe').contentWindow.stopShellLoading();", 50);
					setTimeout("$('disk_iframe').contentWindow.$('dynamicFrame').contentWindow.dataTableObj.initHeaderDivPaddingWidth('view:form1:diskdrives_table');", 200);
				}
			}
			
		}
		//redraw();
	}
	
	this.setTabStatusImage = function(tabIndex, statusImgPath)
	{
		storageTab.setTabStatus(tabIndex, statusImgPath);
	}
	
	this.redrawTabs = function()
	{
		storageTab.redrawTabStatusImage();
	}
	
	this.setVolumeReload = function(flag)
	{
		volumeReload = flag;
	}

	this.setPoolReload = function(flag)
	{
		poolReload = flag;
	}
	
	this.setDiskReload = function(flag)
	{
		diskReload = flag;
	}
}


function redraw()
{
	//redraw tab image after odc client code has refresh it
	setTimeout("frameworkObj.redrawTabs();", 50);
}
