/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2010, 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
// ------------------------------------------ SELECTOIN/FIXING ---------------------------------------------

function checkboxClicked(checkbox, rowIndex)
{
	var table = document.getElementById("diskTable");
	var rows = table.rows;
	
	if(checkbox.checked)
	{
		// This checkbox was just selected, the row style needs to be changed
		rows[rowIndex].className = "scm_DataTableSelected_Row";	
	}
	else
	{
		// The checkbox was unchecked, so make the row a sample color and we will fix it up
		rows[rowIndex].className = "scm_DataTable_Row";
	}
	
	fixUpRowStyles(table);
	enableDisableOKButtons();
}

function enableDisableOKButtons()
{
	// We need to check if any disks are selected and enable/disable the OK button
	if(getNumberSelected() > 0)
	{
		document.getElementById("view:form1:ok_btn").disabled = false;
	}
	else
	{
		document.getElementById("view:form1:ok_btn").disabled = true;
	}
}

function getNumberSelected()
{
	var checkboxes = document.getElementsByName("selectedDisks");
	
	var sum = 0;
	
	for(var x = 0; x < checkboxes.length; x++)
	{
		if(checkboxes[x].checked)
		{
			sum++;
		}
	}
	
	return sum;
}

function fixUpRowStyles(table)
{
	var rows = table.rows;
	// start from 1
	for(var x = 1; x < rows.length; x++)
	{
		// Skip highlighted rows
		if(rows[x].className != "scm_DataTableSelected_Row")
		{
			if(x % 2 == 1)
			{
				rows[x].className = "scm_DataTable_Row";
			}
			else
			{
				rows[x].className = "scm_DataTable_RowGray";
			}
		}
	}
}

function onUnassignSpareError()
{
	//hide the wait div
	$("loading_div").style.display="none";
	//display the fatal message.
	inlineMessagesAjaxObj.displayFatalMessage();
	document.body.style.cursor='default';
	enableAllBtns();
}

function onUnassignSpareComplete()
{
	var unassignSucceed = $("view:form1:unassign_succeed").innerHTML;
	if(unassignSucceed == "true")
	{
		//close self page
		parent.getElementByIdSuffix("form1:dedicated_spare_cancel_btn", "input").click();
	}else{
		//hide the wait div
		$("loading_div").style.display="none";
		inlineMessagesAjaxObj.fetchMessages();
		document.body.style.cursor='default';
		enableAllBtns();
	}
	
};
	
function onUnassignSpareStart()
{
	//display the wait div
	$("loading_div").style.display="block";
	document.body.style.cursor='wait';
	disableAllBtns();
};


function enableAllBtns()
{
	$("view:form1:ok_btn").disabled = false;
	$("view:form1:cancel_btn").disabled = false;
};

function disableAllBtns()
{
	$("view:form1:ok_btn").disabled = true;
	$("view:form1:cancel_btn").disabled = true;
};


