/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2010, 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
var vpObj = new VolumeProperties();

VolumeProperties.GENERAL_TAB = 1;
VolumeProperties.DISK_TAB = 2;
VolumeProperties.ADVANCED_TAB = 3;

function VolumeProperties()
{
	//update action button(s) upon table click
	this.updateActionButton = function()
	{
		var isRowSelected = dataTableObj.isRowSelected();
		if(true == isRowSelected)
		{
			$("view:form1:btn_locate_drive").disabled = false;
		}
		else
		{
			$("view:form1:btn_locate_drive").disabled = true;
		}
	}
	
		//locate disk drives, launch the locateshell jsp.
	this.onClickLocateDrivesBtn = function(thisObj,thisEvent)
	{
		var selectedIds = dataTableObj.getSelectedIds();
		// Make sure to clear out any previously selected resources
		locateObject.removeAllResourcesToLocate();
		// Add the currently selected object
		if(selectedIds != "")
		{
			var selectedIdArray = selectedIds.split(DataTable.ID_DELIMITER);
			for(var i=0; i<selectedIdArray.length; i++)
			{
				locateObject.addResourceToLocate(selectedIdArray[i]);
			}
		}
		locateObject.setLocateType(locateObject.DISK_CONSTANT);
		// Start the locate
		locateObject.startLocate();
	};
	
	this.editVolumeProperty = function()
	{
		parent.volumeObj.launchEditVolumePropertyDialog();
	}
	
	this.switchTab = function()
	{
		var tabIndex = parseInt($("view:tab_idx").innerHTML);
		
		switch(tabIndex)
		{
			case VolumeProperties.ADVANCED_TAB:
				ODCRegistry.getClientControl('volume_tab_panel').restoreUIState("view:form1:volume_tab_panel:volume_advanced");
				break;
			case VolumeProperties.DISK_TAB:
				ODCRegistry.getClientControl('volume_tab_panel').restoreUIState("view:form1:volume_tab_panel:volume_drives");
				break;
			case VolumeProperties.GENERAL_TAB:
			default:
				ODCRegistry.getClientControl('volume_tab_panel').restoreUIState("view:form1:volume_tab_panel:volume_general");
				break;
		}
	}
	
	this.onTabEnter = function(thisObj, thisEvent)
	{
		var panelId = thisEvent.tobeEnterPanel;
		if(panelId.endWith("volume_drives"))
		{
			//adjust the width
			setTimeout("dataTableObj.initHeaderDivPaddingWidth('view:form1:disks_table')", 200);
		}
	}
	
}
