/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2010, 2012 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
var volumeObj = new Volume();

Volume.VOLUMES_DELETE_DIALOG_PATH = "faces/page/storage/DeleteVolumesConfirmation.jsp";
Volume.VOLUME_PROPERTIES_DIALOG_PATH = "faces/page/storage/VolumeProperties.jsp";
Volume.VIEW_FORM_ID = "view:form1";
Volume.VIEW_ID = "view";

var selecteVolumeId;

function Volume()
{
	this.updateLastRefresh = function()
	{
		$("last_refresh_timestamp").innerHTML = getLocalizedCurrentTime();
	}
	
	//update action menu item upon table click
	this.updateMenu = function()
	{
		var isRowSelected = dataTableObj.isRowSelected();
		var menuAttr = "";
		if(true == isRowSelected)
		{
			menuAttr = "disabled:false";
		}
		else
		{
			menuAttr = "disabled:true";
		}
		
		var actionMenu = hX_5.getComponentById("view:form1:actionmenu");
		var selectedRowCount = dataTableObj.getSelectedRowCount();
		
		var item = actionMenu.getMenuItemById("view:form1:properties_link");
		if(selectedRowCount > 1)
		{
			hX_5.getSubComponentById(item).setAttribute("disabled:true");
			$("view:form1:properties_link").onclick="";
		}
		else
		{
			hX_5.getSubComponentById(item).setAttribute(menuAttr);	
			if(menuAttr == "disabled:false")
			{
				$("view:form1:properties_link").onclick=volumeObj.onClickPropertiesMenu;
			}else{
				$("view:form1:properties_link").onclick="";
			}
		}
		
		item = actionMenu.getMenuItemById("view:form1:delete_volume_link");
		hX_5.getSubComponentById(item).setAttribute(menuAttr);
		if(menuAttr == "disabled:false")
		{
			$("view:form1:delete_volume_link").onclick=volumeObj.onClickDeleteVolumesMenu;
		}else{
			$("view:form1:delete_volume_link").onclick="";
		}
		
		item = actionMenu.getMenuItemById("view:form1:locate_drives_link");
		if(selectedRowCount > 1)
		{
			hX_5.getSubComponentById(item).setAttribute("disabled:true");
			$("view:form1:locate_drives_link").onclick="";
		}
		else
		{
			hX_5.getSubComponentById(item).setAttribute(menuAttr);
			if(menuAttr == "disabled:false")
			{
				$("view:form1:locate_drives_link").onclick=volumeObj.onClickLocateDrivesMenu;
			}else{
				$("view:form1:locate_drives_link").onclick="";
			}
		}
	}
	
	//called when user clicks on the volume name link of table to show property dialog
	this.onClickVolumeLink = function(thisObj)
	{
		var oRow = thisObj.parentNode.parentNode.parentNode;
		var volumeId = oRow.cells[0].getElementsByTagName("input")[1].value;
		//Save this volumeid for volume property edit dialog use
		selecteVolumeId = volumeId;
		launchPropertiesDialog(volumeId);
	}

	//called when user clicks on the volume name link of table to show property dialog
	this.onClickPropertiesMenu = function()
	{
		var volumeId = dataTableObj.getSelectedIds();
		launchPropertiesDialog(volumeId);
	}
	
	this.launchPropertiesDialogWithTabIndex = function(tabIndex)
	{
		var volumeId = dataTableObj.getSelectedIds();
		if(!volumeId || volumeId.length == 0)
		{
			volumeId = selecteVolumeId;
		}
		launchPropertiesDialog(volumeId, tabIndex);
	}

	this.onCreateVolume = function()
	{
		parent.parent.parent.getElementByIdSuffix("form1:btn_volume_tab_create_volume", "input").click();
	}
		
	//show the volume deletion confirmation dialog
	this.onClickDeleteVolumesMenu = function()
	{
		launchVolumesDeletionDialog();
	}
	
	//locate disk drives, launch the locateshell jsp.
	this.onClickLocateDrivesMenu = function()
	{
		var selectedIds = dataTableObj.getSelectedIds();
		// Make sure to clear out any previously selected resources
		locateObject.removeAllResourcesToLocate();
		// Add the currently selected object
		if(selectedIds != "")
		{
			var selectedIdArray = selectedIds.split(DataTable.ID_DELIMITER);
			for(var i=0; i<selectedIdArray.length; i++)
			{
				locateObject.addResourceToLocate(selectedIdArray[i]);
			}
		}
		locateObject.setLocateType(locateObject.VOLUME_CONSTANT);
		// Start the locate
		locateObject.startLocate();
	};
	
	
	//click the refresh button
	this.onClickRefreshBtn = function()
	{
		//if click the refresh button, the context will be reloaded, so the others tab pages should be reloaded as well.
		parent.parent.frameworkObj.setDiskReload(true); 
		parent.parent.frameworkObj.setPoolReload(true);
		parent.$('staticLoadingFrame').contentWindow.restartFloatMessage();
		parent.loaded = false;
		parent.startShellLoading();
	}
	
	
	//launch the properties dialog
	function launchPropertiesDialog(volumeId, tabIndex)
	{
		//set title
		var title = $("view:dialog_title").innerHTML;
		setPanelDialogTitle(title);
		var action = Volume.VOLUME_PROPERTIES_DIALOG_PATH;
		panelDialogObj.clearParameter();
		panelDialogObj.addParameter("volumeId", volumeId);
		if(tabIndex)
		{
			panelDialogObj.addParameter("tabindex", tabIndex);
		}
		panelDialogObj.launchDialogPOST(Volume.VIEW_ID,action,'620');
	};
	
	//set the panel dialog title
	function setPanelDialogTitle(title)
	{
		panelDialogObj.setPanelDialogTitle(Volume.VIEW_ID, title);
	};
	
	function launchVolumesDeletionDialog()
	{
		setPanelDialogTitle($('view:delete_volume_dialog_title').innerHTML);
		var selectedIds = dataTableObj.getSelectedIds();
		
		var action = Volume.VOLUMES_DELETE_DIALOG_PATH;
		panelDialogObj.addParameter("volume_ids",selectedIds);
		panelDialogObj.launchDialogPOST(Volume.VIEW_ID,action,'550');
	};
	
	this.launchEditVolumePropertyDialog = function()
	{
		var volumeId = dataTableObj.getSelectedIds();
		if(!volumeId || volumeId.length == 0)
		{
			volumeId = selecteVolumeId;
		}
		evpsObj.setDialogTitle($('view:edit_volume_dialog_title').innerHTML);
		evpsObj.setVolumeID(volumeId);
		evpsObj.launchModal();
	}
}
